<template>
  <div class="rating-right">
    <ob-table
        :items="indicators"
        :columns="columns"
        :functional-panel="true"
        class="rating-right-table"
        :is-functional-sort="false"
        :is-functional-group="false"
    >
      <template v-slot:mark="{ data }">
        <div
            class="rating-right-table__price"
            :class="[data.item.price[0] === '-' ? 'red' : 'green']"
        >{{data.item.price}}</div>
      </template>
      <template v-slot:numberOrder="{ data }">
        <a class="rating-right-table__order">{{data.item.number}}</a>
      </template>
      <template v-slot:route="{ data }">
        <div class="rating-right-table__route">
          <div class="rating-right-table__route-start">
            {{ data.item.startAddress }}
          </div>
          <div class="rating-right-table__route-dots">
            <div v-if="data.item.shipmentPointsCount" class="rating-right-table__route-dots-count">
              +{{data.item.shipmentPointsCount}}
            </div>
          </div>
          <div class="rating-right-table__route-end">
            {{ data.item.endAddress }}
          </div>
        </div>
      </template>
      <template  v-slot:extraFuncToPanel>
        <div class="rating-right-header-tabs">
          <div
              v-for="tab in tabs"
              :key="tab.id"
              @click="setActive(tab.id)"
              class="rating-right-header-tabs__tab"
              :class="{'active': tab.id === activeTab}"
          >
            <span>{{tab.title}}</span>
          </div>
        </div>
      </template>
      <template v-slot:person="{ data }">
        <span>{{data.item.person}}</span>
      </template>
    </ob-table>
  </div>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable';
import moment from 'moment';
import {indicators} from '../mock'
export default {
  name: "rightPanel",
  components: {
    ObTable
  },
  data() {
    return {
      activeTab: 'in_month',
      tabs: [
        {
          id: 'in_month',
          title: 'За месяц'
        },
        {
          id: 'in_quarter',
          title: 'За квартал'
        },
        {
          id: 'in_year',
          title: 'За год'
        }
      ],
      indicators: indicators,
      columns: [
        {
          title: 'Влияние на рейтинг',
          key: 'price',
          slotName: 'mark'
        },
        {
          title: '№ заказа',
          key: 'number',
          slotName: 'numberOrder'
        },
        {
          title: 'Маршрут',
          key: 'route',
          slotName: 'route'
        },
        {
          title: 'Дата разгрузки',
          key: 'completionDt',
          html: (data) => moment(data.completionDt).format('DD.MM.YYYY')
        },
        {
          title: 'Водитель',
          key: 'person',
          slotName: 'person'
        }
      ]
    }
  },
  methods: {
    setActive(tab) {
      this.activeTab = tab;
    }
  }
}
</script>

<style scoped lang="scss">
.rating-right {
  width: 100%;
  &-header {
    border: 1px solid $lavender;
    border-top-left-radius: 3px;
    border-top-right-radius: 3px;
    margin-bottom: -1px;
    &-tabs {
      display: flex;
      align-items: center;
      width: 100%;

      &__tab {
        padding: 7px 12px;
        color: $cobalt-blue;
        background: $background-white;
        border: 1px solid $lavender;
        box-sizing: border-box;
        cursor: pointer;

        &:first-child {
          border-right: none;
          border-top-left-radius: 3px;
          border-bottom-left-radius: 3px;
        }

        &:last-child {
          border-left: none;
          border-top-right-radius: 3px;
          border-bottom-right-radius: 3px;
        }

        &.active {
          background: $blue-blue-hoarfrost;
        }
      }
    }
  }
  &-table {
    &__price {
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      &.green {
        color: $green-craiola;
      }
      &.red {
        color: $color-error;
      }
    }
    &__order {
      letter-spacing: 0.4px;
      font-variant: small-caps;
      color: $blue-700;
      mix-blend-mode: normal;
    }
    &__route {
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $shale-gray;
      width: 300px;
      display: flex;
      justify-content: space-between;
      &-dots {
        display: flex;
        justify-content: center;
        align-items: center;
        flex-grow: 12;
        position: relative;
        margin: 0 8px;

        &::after {
          position: absolute;
          content: '';
          top: 50%;
          width: 100%;
          height: 1px;
          border-top: 1px $blue-blue-hoarfrost dotted;
        }
        &-count {
          background: $background-white;
          display: flex;
          justify-content: center;
          align-items: center;
          padding: 3px;
          height: 16px;
          font-size: 10px;
          line-height: 20px;
          letter-spacing: 1px;
          text-transform: uppercase;
          color: $blue-700;
          border: 1px solid $blue-blue-hoarfrost;
          box-sizing: border-box;
          border-radius: 5px;
          position: relative;
          z-index: 1;
        }
      }
    }
  }
  ::v-deep .ob-func-panel__controls{
    .ob-func-panel{
      &__controls{
        justify-content: flex-start;
        &-side{
          &:last-child{
            width: 100%;
            .ob-func-panel__control{
              &:first-child{
                width: 100%;
              }
              &:last-child{
                display: block;
              }
            }
          }
        }
      }
    }
  }
  ::v-deep table{
    min-width: auto;
  }
}
</style>